using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Net;
using System.IO;

namespace PheonicPluginReader
{
    public partial class Form1 : Form
    {
        #region Instance Data

        private string __curSourceCode__;
        private bool __allChecked1__;
        private bool __allChecked2__;

        #endregion

        #region Accessors

        /// <summary>
        /// CurSourceCode
        /// </summary>
        public string CurSourceCode { get { return __curSourceCode__; } set { __curSourceCode__ = value; } }
        /// <summary>
        /// AllChecked1
        /// </summary>
        public bool AllChecked1 { get { return __allChecked1__; } set { __allChecked1__ = value; } }
        /// <summary>
        /// AllChecked2
        /// </summary>
        public bool AllChecked2 { get { return __allChecked2__; } set { __allChecked2__ = value; } }

        #endregion

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Shown(object sender, EventArgs e)
        {
            try
            {
                GetSourceCode("http://plugins.pheonic.co.uk/");

                // 'Incomplete' plugins.
                int pStart = CurSourceCode.IndexOf("Incomplete Plugins") + 41;
                int pCount = CurSourceCode.IndexOf("</ul>", pStart) - 1;
                int pos = pStart;
                int count = 0;
                CheckedListBox clb = checkedListBox1;
                for (int x = 0; x < 2; x++)
                {
                    while (pos < pCount)
                    {
                        pos += 26;
                        pos = CurSourceCode.IndexOf(">", pos) + 2;
                        count = CurSourceCode.IndexOf("]", pos) - pos;

                        string pClass = CurSourceCode.Substring(pos, count);
                        pClass = pClass.Replace("\"", "");                         // fog
                        pClass = pClass.Replace("&lt;", "_").Replace("&gt;", "_"); // <fx>
                        clb.Items.Add(pClass, true);

                        pos = CurSourceCode.IndexOf("</li>", pos) + 6;
                    }
                    if (x != 1)
                    {
                        // 'Complete' plugins.
                        pStart = CurSourceCode.IndexOf("Complete Plugins") + 39;
                        pCount = CurSourceCode.IndexOf("</ul>", pStart) - 1;
                        pos = pStart;
                        count = 0;
                        clb = checkedListBox2;
                    }
                }

                CurSourceCode = string.Empty;
                AllChecked1 = true;
                AllChecked2 = true;
                textBox1.Text = string.Format("{0}\\Plugins\\", Application.StartupPath);
                textBox2.Text = ".ent";
                slabel.Text = "Idle";
                button1.Enabled = true;
                panel1.Enabled = true;
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message, "", MessageBoxButtons.OK,
                    MessageBoxIcon.Exclamation);

                Application.Exit();
            }
        }

        public void GetSourceCode(string address)
        {
            WebRequest request = WebRequest.Create(new Uri(address));
            Stream stream = request.GetResponse().GetResponseStream();
            StreamReader reader = new StreamReader(stream);
            CurSourceCode = reader.ReadToEnd();
            reader.Close();
        }

        private void button2_Click(object sender, EventArgs e)
        {
            using (FolderBrowserDialog fbd = new FolderBrowserDialog())
            {
                fbd.ShowNewFolderButton = true;
                if (fbd.ShowDialog() == DialogResult.Cancel) return;
                textBox1.Text = fbd.SelectedPath;
            }
        }

        private void textBox12_TextChanged_checkedListBox12_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (sender == textBox2)
            {
                if (textBox2.TextLength == 0) textBox2.Text = ".";
                else if (textBox2.Text[0] != '.') textBox2.Text = textBox2.Text.Insert(0, ".");
            }

            button1.Enabled = (textBox1.TextLength > 0 && textBox2.TextLength > 1 &&
                checkedListBox1.CheckedItems.Count + checkedListBox2.CheckedItems.Count != 0);
        }

        private void checkedListBox1_DoubleClick(object sender, EventArgs e)
        {
            for (int x = 0; x < checkedListBox1.Items.Count; x++)
                checkedListBox1.SetItemChecked(x, !AllChecked1);

            AllChecked1 = !AllChecked1;
        }

        private void checkedListBox2_DoubleClick(object sender, EventArgs e)
        {
            for (int x = 0; x < checkedListBox2.Items.Count; x++)
                checkedListBox2.SetItemChecked(x, !AllChecked2);

            AllChecked2 = !AllChecked2;
        }

        private void button1_Click(object sender, EventArgs e)
        {
            try
            {
                panel1.Enabled = false;
                List<string> pList = new List<string>();

                // Find plugin uri's.

                GetSourceCode("http://plugins.pheonic.co.uk/");

                // 'Incomplete' plugins.
                int pStart = CurSourceCode.IndexOf("Incomplete Plugins") + 41;
                int pCount = CurSourceCode.IndexOf("</ul>", pStart) - 1;
                int pos = pStart;
                int count = 0;
                CheckedListBox clb = checkedListBox1;
                for (int x = 0; x != 2; x++)
                {
                    for (int y = 0; y != clb.Items.Count; y++)
                    {
                        pos += 26;
                        count = CurSourceCode.IndexOf("\"", pos) - pos;

                        if (clb.GetItemChecked(y))
                            pList.Add(CurSourceCode.Substring(pos, count));

                        pos += count;
                        pos = CurSourceCode.IndexOf("</li>", pos) + 6;
                    }
                    if (x != 1)
                    {
                        // 'Complete' plugins.
                        pStart = CurSourceCode.IndexOf("Complete Plugins") + 39;
                        pCount = CurSourceCode.IndexOf("</ul>", pStart) - 1;
                        pos = pStart;
                        count = 0;
                        clb = checkedListBox2;
                    }
                }

                // Create plugins.

                string dir = string.Format("{0}{1}", textBox1.Text, (textBox1.Text[textBox1.TextLength - 1] == '\\' ? string.Empty : "\\"));
                if (!Directory.Exists(dir)) Directory.CreateDirectory(dir);
                string ext = textBox2.Text;

                StringBuilder sb = null;
                pb1.Maximum = pList.Count;

                for (int x = 0; x < pList.Count; x++)
                {
                    pb1.Value = x + 1;
                    slabel.Text = string.Format("Retrieving plugins... ({0}/{1})", x + 1, pList.Count);
                    Application.DoEvents();

                    GetSourceCode(string.Format("http://plugins.pheonic.co.uk{0}", pList[x]));

                    pStart = CurSourceCode.IndexOf("&lt;plugin class=");
                    pCount = CurSourceCode.IndexOf("&lt;/plugin&gt;", pStart) - pStart;

                    sb = new StringBuilder(CurSourceCode.Substring(pStart, pCount));

                    // Parse.
                    sb.Replace("&lt;", "<");
                    sb.Replace("&gt;", ">");
                    sb.Replace("\n", " ");
                    sb.Replace("&nbsp;", " ");
                    sb.Replace("&quot;", "\"");
                    sb.Replace("<br>", "\r\n");
                    sb.Replace("<br />", "\r\n");
                    sb.Replace("<BR>", "\r\n");
                    sb.Replace("<BR />", "\r\n");
                    sb.Replace("</p><p>", "\r\n");
                    sb.Replace("</P> <P>", "\r\n");

                    sb.Append("</plugin>");
                    pStart += 18;

                    string pClass = CurSourceCode.Substring(pStart, CurSourceCode.IndexOf("\"", pStart) - pStart);
                    pClass = pClass.Replace("\"", "");                         // fog
                    pClass = pClass.Replace("&lt;", "_").Replace("&gt;", "_"); // <fx>

                    if (pClass.Length > 4)
                    {
                        pStart += 5;
                        pClass = CurSourceCode.Substring(pStart, CurSourceCode.IndexOf("&quot;", pStart) - pStart);
                    }

                    // Write.
                    StreamWriter sw = File.CreateText(string.Format("{0}{1}{2}", dir, pClass, ext));
                    sw.Write(sb.ToString());
                    sw.Close();
                }
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message, "", MessageBoxButtons.OK,
                    MessageBoxIcon.Exclamation);
            }
            finally
            {
                pb1.Value = 0;
                slabel.Text = "Idle";
                panel1.Enabled = true;
            }
        }
    }
}